﻿Type=Class
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub
'Based on code found here: https://docs.oracle.com/javase/tutorial/reflect/class/classMembers.html

'$"Class Methods for Locating Fields 
'Class API	List of members?	Inherited members?	Private members? 
'getDeclaredField()	no	no	yes 
'getField()	no	yes	no
'getDeclaredFields()	yes	no	yes								3
'getFields()	yes	yes	no										4
'
'Class Methods for Locating Methods
'Class API	List of members?	Inherited members?	Private members?
'getDeclaredMethod()	no	no	yes
'getMethod()	no	yes	no
'getDeclaredMethods()	yes	no	yes								3
'getMethods()	yes	yes	no										4
'
'Class Methods for Locating Constructors
'Class API	List of members?	Inherited members?	Private members?
'getDeclaredConstructor()	no	N/A1	yes
'getConstructor()	no	N/A1	no
'getDeclaredConstructors()	yes	N/A1	yes						3
'getConstructors()	yes	N/A1	no								4
'"$

'Infolevel 3 or 4
Sub LogMembers(Class As Object,InfoLevel As Int)
	
	Dim ClassClass As JavaObject
	Dim ThisClass As Reflector
	
	Log("*************Start***************")
	
	If Class Is String Then
		ClassClass.InitializeStatic("java.lang.Class")
		ThisClass.Target = ClassClass.RunMethod("forName",Array(Class))
	Else
		ClassClass = Class
		ThisClass.Target = ClassClass.RunMethod("getClass",Null)
	End If
	
	LogClass(ThisClass,0,InfoLevel)
	Log("**************End***************")
End Sub

Private Sub LogClass(ThisClass As Reflector,Indent As Int,InfoLevel As Int)	
	
	
	Dim Str As String = "                                                                                                                      "
	Dim IndentStr As String = Str.SubString2(0,Indent * 4)
	
	Log(IndentStr & Indent & ": Class : " & ThisClass.RunMethod("getCanonicalName"))
	
	Dim Package As JavaObject = ThisClass.RunMethod("getPackage")
	Dim PName As String
	If Package <> Null Then 
		PName = Package.RunMethod("getName",Null)
	Else
		PName = "No Package"
	End If
	Log(IndentStr & Indent & ": Package : " & PName)
	
	
	Log(IndentStr & Indent & ": Constructors")
	Dim Constructors() As Object 
	If InfoLevel = 4 Then
		Constructors = ThisClass.RunMethod("getConstructors")
	Else
		Constructors = ThisClass.RunMethod("getDeclaredConstructors")
	End If
	If Constructors.Length = 0 Then
		Log(IndentStr & Indent & ":     " & "None")
	Else
		For Each Constructor As JavaObject In Constructors
			Log(IndentStr & Indent & ":     " & GetType(Constructor))
			Log(IndentStr & Indent & ": " & Constructor.RunMethod("toGenericString",Null))	
		Next
	End If
	
	Log(IndentStr & Indent & ": Fields")
	Dim Fields() As Object
	If InfoLevel = 4 Then
		Fields = ThisClass.RunMethod("getFields")
	Else
		Fields = ThisClass.RunMethod("getDeclaredFields")
	End If
	If Fields.Length = 0 Then
		Log(IndentStr & Indent & ":     " & "None")
	Else
		For Each Field As JavaObject In Fields	
			Log(IndentStr & Indent & ":     " & Field.RunMethod("toGenericString",Null))
		Next
	End If
	
	Log(IndentStr & Indent & ": Methods")
	Dim Methods() As Object
	If InfoLevel = 4 Then
		 Methods = ThisClass.RunMethod("getMethods")
	Else
		Methods = ThisClass.RunMethod("getDeclaredMethods")
	End If
	If Methods.Length = 0 Then
		Log(IndentStr & Indent & ":     " & "None")
	Else
		For Each Method As JavaObject In Methods
			Log(IndentStr & Indent & ":     " & Method.RunMethod("toGenericString",Null))
		Next
	End If
	
	Log(IndentStr & Indent & ": Classes")
	Dim Classes() As Object = ThisClass.RunMethod("getClasses")
	If Classes.Length = 0 Then
		Log(IndentStr & Indent & ":     " & "None")
	Else
		Dim SubClass As Reflector
		For i = 0 To Classes.Length - 1
				SubClass.Target = Classes(i)
				LogClass(SubClass, Indent+1,InfoLevel)
		Next
	End If
End Sub